lantiq: Add support for the BT Home Hub 5A
authorJohn Crispin <john@openwrt.org>
Tue, 7 Jul 2015 13:44:53 +0000 (13:44 +0000)
committerJohn Crispin <john@openwrt.org>
Tue, 7 Jul 2015 13:44:53 +0000 (13:44 +0000)
u-boot support depends on the next "upstream" version ([0]) from
Daniel Schwierzeck.
Since the installation process is quite complicated a "how to" was
added to the wiki: [1]

[0] https://github.com/danielschwierzeck/u-boot-lantiq/tree/openwrt/v2014.01-next
[1] http://wiki.openwrt.org/toh/bt/homehub_v5a

V2: Use the correct PCI interrupt (fixes 2.4GHz wifi)
Signed-off-by: Martin Blumenstingl <martin.blumenstingl@googlemail.com>
SVN-Revision: 46223

target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata [new file with mode: 0644]
target/linux/lantiq/base-files/etc/uci-defaults/01_leds
target/linux/lantiq/base-files/etc/uci-defaults/02_network
target/linux/lantiq/base-files/lib/upgrade/platform.sh
target/linux/lantiq/dts/BTHOMEHUBV5A.dts [new file with mode: 0644]
target/linux/lantiq/image/Makefile
target/linux/lantiq/xrx200/profiles/bt.mk [new file with mode: 0644]

diff --git a/target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata b/target/linux/lantiq/base-files/etc/hotplug.d/firmware/11-ath10k-caldata
new file mode 100644 (file)
index 0000000..0d8084f
--- /dev/null
@@ -0,0 +1,51 @@
+#!/bin/sh
+# Based on ar71xx 11-ath10k-caldata and 10-rt2x00-eeprom
+
+ath10k_caldata_die() {
+       echo "ath10k caldata: " "$*"
+       exit 1
+}
+
+ath10k_caldata_extract() {
+       local part=$1
+       local offset=$2
+       local mtd
+
+       . /lib/functions.sh
+
+       mtd=$(find_mtd_part $part)
+       [ -n "$mtd" ] || \
+               ath10k_caldata_die "no mtd device found for partition $part"
+
+       dd if=$mtd of=/lib/firmware/$FIRMWARE bs=1 skip=$offset count=2116 || \
+               ath10k_caldata_die "failed to extract from $mtd"
+}
+
+ath10k_caldata_set_macaddr() {
+       local macaddr=$1
+
+       macaddr_2bin $macaddr | dd of=/lib/firmware/$FIRMWARE \
+                               conv=notrunc bs=1 seek=6 count=6
+}
+
+[ -e /lib/firmware/$FIRMWARE ] && exit 0
+. /lib/functions.sh
+. /lib/functions/system.sh
+. /lib/functions/lantiq.sh
+
+case "$FIRMWARE" in
+"ath10k/cal-pci-0000:02:00.0.bin")
+       local board=$(lantiq_board_name)
+       case $board in
+               BTHOMEHUBV5A)
+                       local lan_mac=$(mtd_get_mac_binary caldata 4364)
+                       local wifi_mac=$(macaddr_add "$lan_mac" 3)
+                       ath10k_caldata_extract "caldata" 20480
+                       ath10k_caldata_set_macaddr $wifi_mac
+                       ;;
+               *)
+                       ath10k_caldata_die "board $board is not supported yet"
+                       ;;
+       esac
+       ;;
+esac
index 8041ac9..3e05eba 100644 (file)
@@ -25,7 +25,7 @@ BTHOMEHUBV2B)
        ucidef_set_led_netdev "internet" "internet" "soc:blue:broadband" "pppoa-wan"
        ucidef_set_led_usbdev "usb" "usb" "soc:blue:phone" "1-1"
        ;;
-BTHOMEHUBV3A)
+BTHOMEHUBV3A|BTHOMEHUBV5A)
        ucidef_set_led_default "power" "power" "soc:blue:power" "1"
        ucidef_set_led_wlan "wifi" "wifi" "soc:blue:wireless" "phy0tpt"
        ucidef_set_led_netdev "internet" "internet" "soc:blue:broadband" "pppoa-wan"
index afb8714..6f9d9c0 100644 (file)
@@ -169,6 +169,14 @@ BTHOMEHUBV2B|BTHOMEHUBV3A)
        wan_mac=$(macaddr_add "$lan_mac" 1)
        ;;
 
+BTHOMEHUBV5A)
+       lan_mac=$(mtd_get_mac_binary caldata 4364)
+       wan_mac=$(macaddr_add "$lan_mac" 1)
+       ucidef_set_interface_lan 'eth0.1'
+       ucidef_add_switch "switch0" "1" "1"
+       ucidef_add_switch_vlan "switch0" "1" "0 1 2 4 6t"
+       ;;
+
 VGV7519)
        lan_mac=$(mtd_get_mac_binary board_config 22)
        wan_mac=$(macaddr_add "$lan_mac" 1)
index 1688d3a..f255e81 100755 (executable)
@@ -7,7 +7,7 @@ platform_check_image() {
        local board=$(lantiq_board_name)
 
        case "$board" in
-               BTHOMEHUBV2B|BTHOMEHUBV3A|P2812HNUF* )
+               BTHOMEHUBV2B|BTHOMEHUBV3A|BTHOMEHUBV5A|P2812HNUF* )
                        nand_do_platform_check $board $1
                        return $?;
                        ;;
diff --git a/target/linux/lantiq/dts/BTHOMEHUBV5A.dts b/target/linux/lantiq/dts/BTHOMEHUBV5A.dts
new file mode 100644 (file)
index 0000000..e8cdbbf
--- /dev/null
@@ -0,0 +1,287 @@
+/dts-v1/;
+
+/include/ "vr9.dtsi"
+
+/ {
+       model = "BTHOMEHUBV5A - BT Home Hub 5A";
+
+       chosen {
+               bootargs = "console=ttyLTQ0,115200 init=/etc/preinit";
+       };
+
+       memory@0 {
+               reg = <0x0 0x8000000>;
+       };
+
+       fpi@10000000 {
+               localbus@0 {
+                       nand-parts@0 {
+                               compatible = "gen_nand", "lantiq,nand-xway";
+                               lantiq,cs = <1>;
+                               bank-width = <2>;
+                               reg = <0 0x0 0x2000000>;
+                               #address-cells = <1>;
+                               #size-cells = <1>;
+
+                               partition@0 {
+                                       label = "u-boot";
+                                       reg = <0x0 0x40000>;
+                                       read-only;
+                               };
+                               partition@40000 {
+                                       label = "uboot-env";
+                                       reg = <0x40000 0x40000>;
+                               };
+                               caldata: partition@80000 {
+                                       label = "caldata";
+                                       reg = <0x80000 0x20000>;
+                                       read-only;
+                               };
+                               partition@a0000 {
+                                       label = "kernel";
+                                       reg = <0xa0000 0x200000>;
+                               };
+                               partition@2a0000 {
+                                       label = "ubi";
+                                       reg = <0x2a0000 0x7d60000>;
+                               };
+                       };
+               };
+
+               gpio: pinmux@E100B10 {
+                       pinctrl-names = "default";
+                       pinctrl-0 = <&state_default>;
+
+                       interrupt-parent = <&icu0>;
+                       interrupts = <166 135 66 40 41 42 38>;
+
+                       state_default: pinmux {
+                               mdio {
+                                       lantiq,groups = "mdio";
+                                       lantiq,function = "mdio";
+                               };
+                               pci_rst {
+                                       lantiq,pins = "io21";
+                                       lantiq,output = <1>;
+                                       lantiq,open-drain;
+                               };
+                               pcie_rst {
+                                       lantiq,pins = "io38";
+                                       lantiq,pull = <0>;
+                                       lantiq,output = <1>;
+                                       lantiq,open-drain;
+                               };
+                               usb_vbus {
+                                       lantiq,pins = "io33";
+                                       lantiq,pull = <0>;
+                                       lantiq,open-drain = <0>;
+                                       lantiq,output = <1>;
+                               };
+                               nand_out {
+                                       lantiq,groups = "nand cle", "nand ale";
+                                       lantiq,function = "ebu";
+                                       lantiq,output = <1>;
+                                       lantiq,open-drain = <0>;
+                                       lantiq,pull = <0>;
+                               };
+                               nand_cs1 {
+                                       lantiq,groups = "nand cs1";
+                                       lantiq,function = "ebu";
+                                       lantiq,open-drain = <0>;
+                                       lantiq,pull = <0>;
+                               };
+                       };
+               };
+
+               eth@E108000 {
+                       #address-cells = <1>;
+                       #size-cells = <0>;
+                       compatible = "lantiq,xrx200-net";
+                       reg = < 0xE108000 0x3000        /* switch */
+                               0xE10B100 0x70          /* mdio */
+                               0xE10B1D8 0x30          /* mii */
+                               0xE10B308 0x30 >;       /* pmac */
+                       interrupt-parent = <&icu0>;
+                       interrupts = <73 72>;
+
+                       lan: interface@0 {
+                               compatible = "lantiq,xrx200-pdi";
+                               #address-cells = <1>;
+                               #size-cells = <0>;
+                               reg = <0>;
+                               mtd-mac-address = <&caldata 0x110c>;
+                               lantiq,switch;
+
+                               ethernet@0 {
+                                       compatible = "lantiq,xrx200-pdi-port";
+                                       reg = <0>;
+                                       phy-mode = "rgmii";
+                                       phy-handle = <&phy0>;
+                               };
+                               ethernet@1 {
+                                       compatible = "lantiq,xrx200-pdi-port";
+                                       reg = <1>;
+                                       phy-mode = "rgmii";
+                                       phy-handle = <&phy1>;
+                               };
+                               ethernet@2 {
+                                       compatible = "lantiq,xrx200-pdi-port";
+                                       reg = <2>;
+                                       phy-mode = "gmii";
+                                       phy-handle = <&phy11>;
+                               };
+                               ethernet@4 {
+                                       compatible = "lantiq,xrx200-pdi-port";
+                                       reg = <4>;
+                                       phy-mode = "gmii";
+                                       phy-handle = <&phy13>;
+                               };
+                       };
+
+                       wan: interface@1 {
+                               compatible = "lantiq,xrx200-pdi";
+                               #address-cells = <1>;
+                               #size-cells = <0>;
+                               reg = <1>;
+                               mtd-mac-address = <&caldata 0x110c>;
+                               mtd-mac-address-increment = <4>;
+                               lantiq,wan;
+
+                               ethernet@5 {
+                                       compatible = "lantiq,xrx200-pdi-port";
+                                       reg = <5>;
+                                       phy-mode = "rgmii";
+                                       phy-handle = <&phy5>;
+                               };
+                       };
+
+                       mdio@0 {
+                               #address-cells = <1>;
+                               #size-cells = <0>;
+                               compatible = "lantiq,xrx200-mdio";
+
+                               phy0: ethernet-phy@0 {
+                                       reg = <0x0>;
+                                       compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
+                               };
+                               phy1: ethernet-phy@1 {
+                                       reg = <0x1>;
+                                       compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
+                               };
+                               phy5: ethernet-phy@5 {
+                                       reg = <0x5>;
+                                       compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
+                               };
+                               phy11: ethernet-phy@11 {
+                                       reg = <0x11>;
+                                       compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
+                               };
+                               phy13: ethernet-phy@13 {
+                                       reg = <0x13>;
+                                       compatible = "lantiq,phy11g", "ethernet-phy-ieee802.3-c22";
+                               };
+                       };
+               };
+
+               ifxhcd@E101000 {
+                       status = "okay";
+                       gpios = <&gpio 33 0>;
+               };
+
+               pci@E105400 {
+                       status = "okay";
+                       lantiq,bus-clock = <33333333>;
+                       interrupt-map-mask = <0xf800 0x0 0x0 0x7>;
+                       interrupt-map = <0x7000 0 0 1 &icu0 30 1>;
+                       gpio-reset = <&gpio 21 0>;
+               };
+       };
+
+       gphy-xrx200 {
+               compatible = "lantiq,phy-xrx200";
+               firmware1 = "lantiq/vr9_phy11g_a1x.bin";        /*VR9 1.1*/
+               firmware2 = "lantiq/vr9_phy11g_a2x.bin";        /*VR9 1.2*/
+               phys = [ 00 01 ];
+       };
+
+       ath9k_eep {
+               compatible = "ath9k,eeprom";
+               ath,eep-flash = <&caldata 0x1000>;
+               ath,mac-offset = <0x110c>;
+               ath,mac-increment = <2>;
+               ath,pci-slot = <0xe>; /* 14 */
+       };
+
+       gpio-keys-polled {
+               compatible = "gpio-keys-polled";
+               #address-cells = <1>;
+               #size-cells = <0>;
+               poll-interval = <100>;
+
+               reset {
+                       label = "reset";
+                       gpios = <&gpio 2 1>;
+                       linux,code = <0x198>;
+               };
+
+               wps {
+                       label = "wps";
+                       gpios = <&gpio 25 1>;
+                       linux,code = <0x211>;
+               };
+
+               restart {
+                       label = "restart";
+                       gpios = <&gpio 39 1>;
+                       linux,code = <0x198>;
+               };
+       };
+
+       gpio-leds {
+               compatible = "gpio-leds";
+
+               broadband-red {
+                       label = "soc:red:broadband";
+                       gpios = <&gpio 0 1>;
+               };
+               broadband-green {
+                       label = "soc:green:broadband";
+                       gpios = <&gpio 3 1>;
+               };
+               broadband-blue {
+                       label = "soc:blue:broadband";
+                       gpios = <&gpio 8 1>;
+               };
+
+               wireless-red {
+                       label = "soc:red:wireless";
+                       gpios = <&gpio 9 1>;
+               };
+               wireless-green {
+                       label = "soc:green:wireless";
+                       gpios = <&gpio 10 1>;
+               };
+               wireless-blue {
+                       label = "soc:blue:wireless";
+                       gpios = <&gpio 11 1>;
+               };
+
+               power-red {
+                       label = "soc:red:power";
+                       gpios = <&gpio 12 1>;
+               };
+               power-green {
+                       label = "soc:green:power";
+                       gpios = <&gpio 14 1>;
+               };
+               power-blue {
+                       label = "soc:blue:power";
+                       gpios = <&gpio 15 1>;
+               };
+
+               dimmed {
+                       label = "dimmed";
+                       gpios = <&gpio 19 0>;
+               };
+       };
+};
index 3e8c20b..726092d 100644 (file)
@@ -414,6 +414,9 @@ Image/Build/Profile/P2812HNUF3=$(call Image/BuildNAND/$(1),$(1),P2812HNUF3)
 Image/BuildKernel/Profile/ARV7519RW22=$(call Image/BuildKernel/Template,ARV7519RW22,$(1))
 Image/Build/Profile/ARV7519RW22=$(call Image/Build/$(1),$(1),ARV7519RW22)
 
+Image/BuildKernel/Profile/BTHOMEHUBV5A=$(call Image/BuildKernel/Template,BTHOMEHUBV5A)
+Image/Build/Profile/BTHOMEHUBV5A=$(call Image/BuildNAND/$(1),$(1),BTHOMEHUBV5A)
+
 Image/BuildKernel/Profile/EASY80920NAND=$(call Image/BuildKernel/Template,EASY80920NAND)
 Image/Build/Profile/EASY80920NAND=$(call Image/Build/$(1),$(1),EASY80920NAND)
 
diff --git a/target/linux/lantiq/xrx200/profiles/bt.mk b/target/linux/lantiq/xrx200/profiles/bt.mk
new file mode 100644 (file)
index 0000000..a1083bb
--- /dev/null
@@ -0,0 +1,9 @@
+define Profile/BTHOMEHUBV5A
+  NAME:=BT Home Hub 5A
+  PACKAGES:=kmod-ath9k kmod-ath10k wpad-mini kmod-usb-dwc2
+endef
+
+BTHOMEHUBV5A_UBIFS_OPTS:="-m 2048 -e 126KiB -c 4096"
+BTHOMEHUBV5A_UBI_OPTS:="-m 2048 -p 128KiB -s 512"
+
+$(eval $(call Profile,BTHOMEHUBV5A))